export var cardbookNewPreferences = {

	allPrefs: {},
	prefCardBookData: "data.",
	prefCardBookTels: "tels.",
	prefCardBookIMPPs: "impps.",
	prefCardBookCustomFields: "customFields.",
	prefCardBookAccountVCards: "vcards.",
	prefCardBookAccountRestrictions: "accountsRestrictions.",
	prefCardBookEmailsCollection: "emailsCollection.",
	prefCardBookCustomTypes: "customTypes.",
	changedPrefs: {
		"addonVersion": "93.6",
		"window.wdw_cardEdition.html.state": {"width": 600, "height": 700},
	},
	defaultPrefs: {
		"autocompletion": true,
		"autocompleteSortByPopularity": true,
		"proposeConcatEmails": false,
		"autocompleteShowAddressbook": false,
		"autocompleteShowEmailType": false,
		"autocompleteShowPopularity": false,
		"autocompleteWithColor": true,
		"autocompleteRestrictSearch": false,
		"autocompleteRestrictSearchFields": "firstname|lastname",
		"useColor": "background",
		"exclusive": false,
		"requestsTimeout": "120",
		"statusInformationLineNumber": "250",
		"debugMode": false,
		"preferEmailEdition": true,
		"listTabView": true,
		"technicalTabView": true,
		"vcardTabView": true,
		"keyTabView": true,
		"panesView": "modern",
		"syncAfterChange": true,
		"initialSync": true,
		"initialSyncDelay": "0",
		"solveConflicts": "User",
		"multiget": "100",
		"maxModifsPushed": "100",
		"decodeReport": true,
		"preferEmailPref": true,
		"preferIMPPPref": true,
		"warnEmptyEmails": true,
		"useOnlyEmail": false,
		"fieldsNameList": "allFields",
		"fieldsNameListUpdate1": true,
		"fieldsNameListUpdate2": true,
		"fieldsNameListUpdate3": false,
		"autoComputeFn": true,
		"usePreferenceValue": false,
		"firstRun": true,
		"kindCustom": "X-ADDRESSBOOKSERVER-KIND",
		"memberCustom": "X-ADDRESSBOOKSERVER-MEMBER",
		"localizeEngine": "OpenStreetMap",
		"localizeTarget": "out",
		"showNameAs": "DSP",
		"adrFormula": messenger.i18n.getMessage("addressFormatFormula"),
		"defaultFnFormula": "({{1}} |)({{2}} |)({{3}} |)({{4}} |)({{5}} |)({{6}} |)({{7}}|)",
		"dateDisplayedFormat": "0",
		"addressBooksNameList": "allAddressBooks",
		"birthday.bday": true,
		"birthday.anniversary": true,
		"birthday.deathdate": true,
		"birthday.events": true,
		"numberOfDaysForSearching": "30",
		"showPopupOnStartup": false,
		"showPeriodicPopup": false,
		"periodicPopupIime": "08:00",
		"showPopupEvenIfNoBirthday": true,
		"syncWithLightningOnStartup": false,
		"numberOfDaysForWriting": "365",
		"eventEntryTitle": messenger.i18n.getMessage("eventEntryTitleMessage"),
		"calendarEntryCategories": messenger.i18n.getMessage("anniversaryCategory"),
		"eventEntryTime": "00:00",
		"repeatingEvent": true,
		"eventEntryWholeDay": false,
		"calendarEntryAlarm": "168",
		"calendarEntryAlarmMigrated": false,
		"viewABPane": true,
		"viewABContact": true,
		"accountsShown": "all",
		"defaultRegion": "NOTSET",
		"localDataEncryption": false,
		"localDataEncryption.validatedVersion": "",
		"localDataEncryption.counter": "",
		"uncategorizedCards": messenger.i18n.getMessage("uncategorizedCards"),
		// not UI accessible prefs
		"maxUndoChanges": "100",
		"currentUndoId": "0",
		"setupCardDAVAccounts": "",
		"URLPhoneURL": "",
		"URLPhoneUser": "",
		"URLPhoneBackground": false,
		"cardbookToolbar.currentset": "",
		"cardbookToolbar.mode": "",
		"discoveryAccountsNameList": "",
		"preferenceValueLabel": "",
		"orgStructure": "",
		"calendarsNameList": "",
		"calendarEntryCategories": "",
		"accountShown": "",
		"supportedVersion": ["3.0", "4.0"],
		"prefs.lastSelected": "cardbook-generalPane",
		"searchAllAB": "allAB",
		"cardbookAccountsTreeWidth": "300",
		"cardbookCardsTreeWidth": "500",
		"cardbookCardsTreeHeight": "500",
		"exportDelimiter": ";",
		"availableCardsTreeDefaultColumns": "cardIcon,fn:150",
		"availableCardsTreeSortResource": "fn",
		"availableCardsTreeSortDirection": "ascending",
		"addedCardsTreeDefaultColumns": "cardIcon,fn:150",
		"addedCardsTreeSortResource": "fn",
		"addedCardsTreeSortDirection": "ascending",
		"window.wdw_cardbookConfigurationAddCustomField.html.state": {"width": 500, "height": 300},
		"window.wdw_csvTranslator.html.state": {"width": 700, "height": 600},
		"window.wdw_cardbookConfigurationEditField.html.state": {"width": 600, "height": 500},
		"window.wdw_cardbookConfigurationAddVcards.html.state": {"width": 600, "height": 500},
		"window.wdw_cardbookConfigurationAddEmails.html.state": {"width": 600, "height": 400},
		"window.wdw_cardbookConfigurationRenameField.html.state": {"width": 500, "height": 300},
		"window.wdw_cardbookConfigurationAddIMPP.html.state": {"width": 600, "height": 300},
		"window.wdw_cardbookConfiguration.html.state": {"width": 600, "height": 500},
		"window.wdw_addressbooksAdd.html.state": {"width": 900, "height": 800},
		"window.wdw_formatData.html.state": {"width": 900, "height": 600},
		"window.wdw_logEdition.html.state": {"width": 900, "height": 600},
		"window.wdw_cardbookRenameField.html.state": {"width": 400, "height": 100},
		"window.wdw_cardbookAskUser.html.state": {"width": 900, "height": 300},
		"window.wdw_bulkOperation.html.state": {"width": 400, "height": 200},
		"window.wdw_birthdayList.html.state": {"width": 600, "height": 500},
		"window.wdw_birthdaySync.html.state": {"width": 400, "height": 300},
		"window.wdw_cardbookEventContacts.html.state": {"width": 600, "height": 500},
		"window.wdw_cardEdition.html.state": {"width": 600, "height": 700},
	},

	initPrefs: async function () {
		let data = await browser.storage.local.get();
		for (const [key, value] of Object.entries(data)) {
			cardbookNewPreferences.allPrefs[key] = value;
		}
		for (const [key, value] of Object.entries(this.defaultPrefs)) {
			if ("undefined" == typeof(data[key])) {
				await cardbookNewPreferences.setPref(key, value);
				cardbookNewPreferences.allPrefs[key] = value;
			}
		}
		for (const [key, value] of Object.entries(this.changedPrefs)) {
			await cardbookNewPreferences.setPref(key, value);
			cardbookNewPreferences.allPrefs[key] = value;
		}
	},

	loadPrefs: async function () {
		let data = await browser.storage.local.get();
		for (const [key, value] of Object.entries(data)) {
			cardbookNewPreferences.allPrefs[key] = value;
		}
	},
	
	removePrefs: async function (keys) {
		await browser.storage.local.remove(keys);
	},

	clear: async function () {
		await browser.storage.local.clear();
	},

	getAllPrefs: function () {
		return cardbookNewPreferences.allPrefs;
	},

	getPref: function (key) {
		return cardbookNewPreferences.allPrefs[key];
	},

    setPref: async function (key, value) {
		cardbookNewPreferences.allPrefs[key] = value;
		await browser.storage.local.set({ [key]: value});
	},

	getBranch: function (aStartingPoint) {
		let childList = this.getAllPrefs();
		let values = [];
		for (const [key, value] of Object.entries(childList)) {
			if (key.startsWith(aStartingPoint)) {
				values.push([key, value]);
			}
		}
		return values;
	},

	getBranchKeys: function (aStartingPoint) {
		let childList = this.getAllPrefs();
		let keys = [];
		for (const [key, value] of Object.entries(childList)) {
			if (key.startsWith(aStartingPoint)) {
				keys.push(key);
			}
		}
		return keys;
	},

	delBranch: async function (aStartingPoint) {
		let keys = this.getBranchKeys(aStartingPoint);
		await this.removePrefs(keys);
	},

	sortMultipleArrayByNumber: function (aArray, aIndex, aInvert) {
		function compare1(a, b) { return (a[aIndex] - b[aIndex])*aInvert; };
		function compare2(a, b) { return (a - b)*aInvert; };
		if (aIndex != -1) {
			return aArray.sort(compare1);
		} else {
			return aArray.sort(compare2);
		}
	},

	// return { pers: [], personal: [ [ "X-CUSTOM2", "Custom2", 0 ] ], org: [] }
	getAllCustomFields: function () {
		var finalResult = {};
		// to delete pers
		for (let type of [ 'pers', 'personal', 'org' ]) {
			finalResult[type] = [];
			let search = this.prefCardBookCustomFields + type + ".";
			let childList = this.getBranch(search);
			for (let result of childList) {
				let rank = result[0].replace(search, "");
				let values = result[1].split(":");
				finalResult[type].push([values[0], values[1], parseInt(rank)]);
			}
			this.sortMultipleArrayByNumber(finalResult[type],2,1);
		}
		return finalResult;
	},

	// return Array [ [ "true", "allMailAccounts", "fe6bbe94-4114-45b0-a596-37082163b7db", "1a4fb09f-7df4-4fc5-995a-b7262de591dd", "file.vcf" ], ]
	getAllVCards: function () {
		var finalResult = [];
		let search = this.prefCardBookAccountVCards;
		let childList = this.getBranch(search);
		for (let result of childList) {
			finalResult.push(result[1].split("::"));
		}
		return finalResult;
	},

	// return Array [ [ "true", "exclude", "allMailAccounts", "fe6bbe94-4114-45b0-a596-37082163b7db", "cat" ], ]
	getAllRestrictions: function () {
		var finalResult = [];
		let search = this.prefCardBookAccountRestrictions;
		let childList = this.getBranch(search);
		for (let result of childList) {
			finalResult.push(result[1].split("::"));
		}
		return finalResult;
	},

	// return Array [ [ "true", "allMailAccounts", "fe6bbe94-4114-45b0-a596-37082163b7db", "cat" ], ]
	getAllEmailsCollections: function () {
		var finalResult = [];
		let search = this.prefCardBookEmailsCollection;
		let childList = this.getBranch(search);
		for (let result of childList) {
			finalResult.push(result[1].split("::"));
		}
		return finalResult;
	},

	// return Array [ [ "imppcode", "impplabel", "imppprot", 0 ], ]
	getAllIMPPs: function () {
		var finalResult = [];
		let search = this.prefCardBookIMPPs;
		let childList = this.getBranch(search);
		for (let result of childList) {
			let rank = result[0].replace(search, "");
			let values = result[1].split(":");
			finalResult.push([values[0], values[1], values[2], parseInt(rank)]);
		}
		this.sortMultipleArrayByNumber(finalResult,3,1);
		return finalResult;
	},

	// return [ [ "telcode", "tellabel", "telprot", 0 ], ]
	getAllTels: function () {
		var finalResult = [];
		let search = this.prefCardBookTels;
		let childList = this.getBranch(search);
		for (let result of childList) {
			let rank = result[0].replace(search, "");
			let values = result[1].split(":");
			finalResult.push([values[0], values[1], values[2], parseInt(rank)]);
		}
		this.sortMultipleArrayByNumber(finalResult,3,1);
		return finalResult;
	},

	getAllPrefIds: function () {
		var finalResult = [];
		let search = this.prefCardBookData;
		let childList = this.getBranch(search);
		for (let result of childList) {
			let prop = result[0].replace(search, "");
			let tmpArray = prop.split('.');
			if (tmpArray[1] == "id") {
				finalResult.push(result[1]);
			}
		}
		return finalResult;
	},

	getABProperty: function (aDirPrefId, aProperty) {
		return cardbookNewPreferences.allPrefs[this.prefCardBookData + aDirPrefId + "." + aProperty];
	},

	getName: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "name");
	},

	getType: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "type");
	},

	getEnabled: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "enabled");
	},

	getVCardVersion: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "vCard");
	},

	getColor: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "color");
	},

	getUrl: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "url");
	},

	getUser: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "user");
	},

	getReadOnly: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "readonly");
	},

	getUrnuuid: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "urnuuid");
	},

	getDBCached: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "DBcached");
	},

	getAutoSyncEnabled: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "autoSyncEnabled");
	},

	getLastSync: function (aDirPrefId) {
		return this.getABProperty(aDirPrefId, "lastsync");
	},

	getAutoSyncInterval: function (aDirPrefId) {
		let autoSyncInterval = this.getABProperty(aDirPrefId, "autoSyncInterval");
		if (autoSyncInterval) {
			return autoSyncInterval;
		} else {
			return "60";
		}
	},
	
	getNode: function (aDirPrefId) {
		let node = this.getABProperty(aDirPrefId, "node");
		if (node) {
			return node;
		} else {
			return "categories";
		}
	},

	getDefaultFnFormula: function () {
		return cardbookNewPreferences.allPrefs["defaultFnFormula"];
	},

	getFnFormula: function (aDirPrefId) {
		if (aDirPrefId) {
			let fnFormula = this.getABProperty(aDirPrefId, "fnFormula");
			if (fnFormula) {
				return fnFormula;
			} else {
				return this.getDefaultFnFormula();
			}
		} else {
			return this.getDefaultFnFormula();
		}
	},

	getDefaultTreeColumns: function (treename) {
		return cardbookNewPreferences.allPrefs[`${treename}DefaultColumns`];
	},

	getTreeColumns: function (treename) {
		let treeColumns = this.getPref(`${treename}Columns`);
		if (treeColumns) {
			return treeColumns;
		} else {
			return this.getDefaultTreeColumns(treename);
		}
	}
};

await cardbookNewPreferences.loadPrefs();

browser.storage.local.onChanged.addListener((info => {
	for (const [key, value] of Object.entries(info)) {
		if (value.oldValue && value.newValue) {
			cardbookNewPreferences.allPrefs[key] = value.newValue;
		} else if (value.oldValue) {
			delete cardbookNewPreferences.allPrefs[key];
		} else {
			cardbookNewPreferences.allPrefs[key] =  value.newValue;
		}
	}
}));
