var { cardbookRepository } = ChromeUtils.import("chrome://cardbook/content/cardbookRepository.js");
cardbookRepository.cardbookCatDatabase.db.close();
cardbookRepository.cardbookDatabase.db.close();
cardbookRepository.cardbookActionsDatabase.db.close();
cardbookRepository.cardbookMailPopDatabase.db.close();
cardbookRepository.cardbookPrefDispNameDatabase.db.close();
cardbookRepository.cardbookSearchDatabase.db.close();
cardbookRepository.cardbookImageDatabase.db.close();
if (cardbookRepository.cardbookDuplicateDatabase.db) {
	cardbookRepository.cardbookDuplicateDatabase.db.close();
}

let JSMs = [
	"chrome://cardbook/content/addressbooksconfiguration/wdw_addressbooksAdd.js",
	"chrome://cardbook/content/addressbooksconfiguration/wdw_addressbooksEdit.js",
	"chrome://cardbook/content/attachvCard/cardbookAttachvCard.jsm",
	"chrome://cardbook/content/autocomplete/LDAPAbCardFormatter.jsm",
	"chrome://cardbook/content/autocomplete/cardbookAutocomplete.js",
	"chrome://cardbook/content/autocomplete/cardbookAutocompleteSearch.js",
	"chrome://cardbook/content/birthdays/cardbookBirthdaysUtils.js",
	"chrome://cardbook/content/birthdays/ovl_birthdays.js",
	"chrome://cardbook/content/birthdays/wdw_birthdayList.js",
	"chrome://cardbook/content/birthdays/wdw_birthdaySync.js",
	"chrome://cardbook/content/cardEdition/wdw_imageEdition.js",
	"chrome://cardbook/content/collected/cardbookCollection.jsm",
	"chrome://cardbook/content/complexSearch/cardbookHTMLComplexSearch.mjs",
	"chrome://cardbook/content/composeMsg/ovl_cardbookComposeMsg.js",
	"chrome://cardbook/content/composeMsg/wl_cardbookComposeMsg.js",
	"chrome://cardbook/content/configuration/wdw_cardbookConfiguration.js",
	"chrome://cardbook/content/configuration/wdw_cardbookConfigurationAddCustomField.js",
	"chrome://cardbook/content/configuration/wdw_cardbookConfigurationAddEmails.js",
	"chrome://cardbook/content/configuration/wdw_cardbookConfigurationAddIMPP.js",
	"chrome://cardbook/content/configuration/wdw_cardbookConfigurationAddVcards.js",
	"chrome://cardbook/content/contactsSidebar/ovl_cardbookContactsSidebarMain.js",
	"chrome://cardbook/content/contactsSidebar/wdw_cardbookContactsSidebar.js",
	"chrome://cardbook/content/csvTranslator/wdw_csvTranslator.js",
	"chrome://cardbook/content/customizeToolbar/wl_customizeToolbar.js",
	"chrome://cardbook/content/enigmail/cardbookEnigmail.js",
	"chrome://cardbook/content/filters/cardbookFilterAction.js",
	"chrome://cardbook/content/filters/ovl_filters.js",
	"chrome://cardbook/content/findDuplicates/cardbookDuplicate.js",
	"chrome://cardbook/content/findDuplicates/wdw_findDuplicates.js",
	"chrome://cardbook/content/formatEmailCorrespondents/ovl_formatEmailCorrespondents.js",
	"chrome://cardbook/content/formautofill/phonenumberutils/PhoneNumber.jsm",
	"chrome://cardbook/content/formautofill/phonenumberutils/PhoneNumberMetaData.jsm",
	"chrome://cardbook/content/formautofill/phonenumberutils/PhoneNumberNormalizer.jsm",
	"chrome://cardbook/content/layout/ovl_cardbookLayout.js",
	"chrome://cardbook/content/lightning/ovl_lightningAttendees.js",
	"chrome://cardbook/content/lightning/wdw_cardbookEventContacts.js",
	"chrome://cardbook/content/lightning/wl_lightningAttendees.js",
	"chrome://cardbook/content/lists/cardbookListConversion.js",
	"chrome://cardbook/content/lists/ovl_list.js",
	"chrome://cardbook/content/mailContact/ovl_cardbookFindEmails.js",
	"chrome://cardbook/content/mailContact/ovl_cardbookFindEvents.js",
	"chrome://cardbook/content/ovl_cardbookAboutMessage.js",
	"chrome://cardbook/content/mergeCards/wdw_mergeCards.js",
	"chrome://cardbook/content/migrate/cardbookMigrate.jsm",
	"chrome://cardbook/content/observers/cardBookComposeMsgObserver.js",
	"chrome://cardbook/content/observers/cardBookLightningObserver.js",
	"chrome://cardbook/content/observers/cardBookObserver.js",
	"chrome://cardbook/content/observers/cardBookObserverRepository.js",
	"chrome://cardbook/content/observers/cardBookSideBarObserver.js",
	"chrome://cardbook/content/observers/cardBookWindowObserver.js",
	"chrome://cardbook/content/preferences/cardbookPreferences.jsm",
	"chrome://cardbook/content/print/cardbookPrint.js",
	"chrome://cardbook/content/print/wdw_cardbookPrint.js",
	"chrome://cardbook/content/simpleMailRedirection/simpleMailRedirection.js",
	"chrome://cardbook/content/cardbookActions.js",
	"chrome://cardbook/content/cardbookCardParser.js",
	"chrome://cardbook/content/cardbookCategoryParser.js",
	"chrome://cardbook/content/cardbookClipboard.js",
	"chrome://cardbook/content/cardbookDates.jsm",
	"chrome://cardbook/content/cardbookHTMLCardsTree.js",
	"chrome://cardbook/content/cardbookHTMLDirTree.js",
	"chrome://cardbook/content/cardbookDiscovery.jsm",
	"chrome://cardbook/content/cardbookElementTools.js",
	"chrome://cardbook/content/cardbookHttpRequest.jsm",
	"chrome://cardbook/content/indexedDB/cardbookEncryptor.js",
	"chrome://cardbook/content/indexedDB/cardbookIndexedDB.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBCard.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBCat.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBUndo.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBImage.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBMailPop.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBPrefDispName.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBSearch.js",
	"chrome://cardbook/content/indexedDB/cardbookIDBDuplicate.js",
	"chrome://cardbook/content/cardbookInit.js",
	"chrome://cardbook/content/cardbookLog.jsm",
	"chrome://cardbook/content/cardbookNotifications.js",
	"chrome://cardbook/content/CardBookNotifyListener.js",
	"chrome://cardbook/content/cardbookPasswordManager.jsm",
	"chrome://cardbook/content/cardbookRichContext.js",
	"chrome://cardbook/content/cardbookSynchro.js",
	"chrome://cardbook/content/cardbookSynchronization.jsm",
	"chrome://cardbook/content/cardbookSynchronizationGoogle2.jsm",
	"chrome://cardbook/content/cardbookTypes.jsm",
	"chrome://cardbook/content/cardbookUtils.jsm",
	"chrome://cardbook/content/cardbookWebDAV.js",
	"chrome://cardbook/content/cardbookWindowUtils.js",
	"chrome://cardbook/content/ovl_cardbook.js",
	"chrome://cardbook/content/bulkOperation/wdw_bulkOperation.js",
	"chrome://cardbook/content/wdw_cardbook.js",
	"chrome://cardbook/content/askUser/wdw_cardbookAskUser.js",
	"chrome://cardbook/content/renameField/wdw_cardbookRenameField.js",
	"chrome://cardbook/content/log/wdw_logEdition.js",
	"chrome://cardbook/content/wl_cardbookMessenger.js",
	"chrome://cardbook/content/cardbookRepository.js",
	"chrome://cardbook/content/cardbookHTMLCardsTree.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeSelection.js",
	"chrome://cardbook/content/cardbookHTMLCardSearch.js",
	"chrome://cardbook/content/cardbookHTMLPaneSplitter.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeView.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTable.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTableHeader.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTableHeaderCell.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTableColumnPicker.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTableBody.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTableRow.js",
	"chrome://cardbook/content/cardbookHTMLCardsTreeViewTableSpacer.js",
];

for (let jsm of JSMs) {
	console.log("Unloading: " + jsm);
	Cu.unload(jsm);
}
